Descritpion

Description of the Applications Package

EasyGen™ is an applications package for the Windows 95/98/2000/ME and the Windows NT environment, designed to simplify the creation of personalized software for Formula batch terminals. It facilitates the creation of programs so that even users who are not programming experts can create software which can be transferred to Formula batch terminals.

EasyGen™ permits the user to define the sequence of functions which the Formula batch terminal should execute, the interactions with the user, and the use of data or support tables. It loads the interpreter program EIXXX_YYY.HEX, the application program, and the associated tables onto the Formula batch terminals using the relative cradle connected to the PC via an RS-232 port.

Currently EasyGen™ functions on Formula batch terminals F734, F732, F725 and F660.


Configuration

Minimum Configuration Required

In order to install and use the EasyGen™ application program, it is necessary to have at least the following:

  • PC with a Pentium processor;
  • One of the following operating systems:

Windows 95 - SR2 or later

Windows 98

Windows 2000

Windows ME

Windows NT + Service Pack 4

  • Internet Explorer 4.01 SP2 (installed in the Active Desktop);
  • *HTML Help Viewer 1.32 (available in EasyGen™ installation directory);
  • a free serial port;
  • 16 MB memory for Windows 95/98, 32 MB for Windows 2000/ME/NT;
  • hard disk with at least 30 MB free space to run;
  • VGA video card or better.

* Advised only for Windows NT 4.0 or Windows 95.


Installation

Once the CD is inserted, launch the Windows software application EasyGen™ for WIN 95/98/2000/ME/NT by pressing the Setup button. Through this procedure the following programs will be also installed:

  • EASYGEN.EXE

permits the creation and modification of personalized application programs and their loading onto a Formula batch terminal.

  • DOSDL.EXE

this allows you to load the Interpreter Program, the application program (which was created with EasyGen™), and the tables associated with it onto a Formula batch terminal with a PC running DOS.

  • EIXXX_YYY.HEX

permits the interpretation by Formula batch terminals of operations defined with the application program EasyGen™. The characters xxx refer to the terminal name, while yyy indicate the software version.

  • SYSTOOLS™
    2001

permits the connection of the computer to the terminal via a cradle, for configuration and the creation of archives containing collected data.

  • OLE for Formula

is for very skilled users only. It can be used to load applications and collect data from the Formula batch terminals from within your own application, using any Development System for Windows that supports the "Microsoft OLE" Technology.


PowerGen

Use and Functioning

  • Use of EasyGen™
  • Description of the Main Menu
  • File
  • Edit
  • Insert
  • Run
  • Tools
  • Utility
  • Window
  • Transmission
  • Data to the Host Computer


Start up

Use of EasyGen™

To develop a new program with EasyGen™ it is necessary to proceed with the following phases:

  • perform an analysis of the problem and define the flow chart using the available functions;
  • open a new program [File menu - New];
  • choose the type of Formula terminal to be used;
  • define the tables and fields [Tools menu - Editor Tables];
  • define names for variables [Tools menu - Editor Variables];
  • proceed with the insertion of all the functions that must be executed by the terminal [Insert menu];
  • save the program [File menu - Save];
  • send the interpreter program EIXXX_YYY.HEX to the Formula terminal (this "Initialization" operation is only performed the first time that a program must be loaded) [Utility menu - Initiate...];
  • load the actual application program on the Formula terminal [File menu - Send].

Limits of EasyGen™

Message/Comment: | This is a sequence of 32 maximum alphanumeric characters;
Number: | is formed by a maximum of 7 integers and two decimal numbers in the format ±XXXXXXX,YY The programmer is responsible to ensure that all numerical operations do not exceed this limit;
Variables: | 7 temporary variables of a maximum of 32 alphanumeric characters are available. The first one is reserved as an "Error Variable", the other 6 can be named.
Tables: | It is possible to use simultaneously up to 15 tables (1..15). In general, table 0 is used to store acquired data. A numeric index variable is associated with each table. Tables are composed of records and each record can have a maximum of 30 fields (see Editor Tables). The index variable points to the nth record. It assumes the minimum value of zero, or "first record", and the maximum value of "maximum number of records" minus one.

Error reporting

There is an error variable which reports several possible error conditions:

Type Error | Variable Value
No error | 00
<F1> button has been pressed | 1
Division by zero | 10
Table limit reached | 30
Data code not suitable for destination field | 31

It is the responsibility of the programmer to make sure that the inserted function does not generate one of these errors with the comparison function.

The "error variable" must be set to the value "00" at program start and reset after each reporting of an error value.


Main menu

Description of the Main Menu

The main menu of the EasyGen™ environment appears at the top of the window when you start the program:

The icons on the first line correspond to the function keys of the File and Tools choice, while the icons of the second line correspond to the function keys of the Insert choice.

On the following pages is a detailed description of the usage of each choice on the main menu.


File Menu

  • New
  • Open
  • Save
  • Save As
  • Print Setup
  • Print
  • Send
  • Export
  • Exit


New

Choosing this command permits you to create a new application program. The following dialog box appears on the screen.

The upper part of the application window shows the type of Formula terminal the program is to run on. With the down arrow it is possible to choose the Formula terminal, and EasyGen™ adapts the base program to the model of the terminal chosen.

To insert instructions into the list, it is necessary to use the Insert option of the main menu, or choose one of the respective icons.

Each function consists of three columns:

Function name

By selecting this box it is possible to change the name of a function directly within the window; the name can be of any length and identifies the function. The system suggests a default name with progressive numbers automatically.

Function type

When this box is chosen, a window appears with all the possible functions, and the function type can be changed.

Skip function

Selecting this box opens a window showing from which functions a skip in the currently is made.

The function position can be changed within the window through the Drag and Drop procedure. If the CTRL key is pressed simultaneously, the dragged function will then be copied.


Open

With this command it is possible to open a previously created application program. The following selection dialog box appears on the screen.


Save

This choice allows you to save an application program which you have created. This command saves immediately the currently open application. Note that it will not prompt for a name. If the open program is not already named, EasyGen™ will assign one of the format Applicationx.APP, where x is a progressive number. A file with the same name and PWT extension (Applicationx.PWT) will be automatically saved. This file contains the name of theFormula terminal and is useful for some terminal-dependent instructions. If this file does not exist "Formula 734" will be the default terminal.


Save As...

This command can be useful when you wish to modify a program and save it to disk with a different name, without modifying the original.


Print Setup

This command permits you to select a printer and to specify print options, page size, orientation, etc...in a standard printer setup dialog of Windows 95/98/2000/ME or NT.


Print

This command permits you to print the current application program. The following dialog box appears on the screen:

It is possible to choose which portions of the application program to print:

Options/Tables/Variables: | The information defined with the Tools menu is printed;
Functions: | The program is printed with the functions defined by the Insert menu. It is also possible to select printing of the function properties desired.


Send

With this command it is possible to transmit the application program to the Formula terminal. The following dialog box appears on the screen:

It is necessary to indicate which port the Formula terminal is connected to. At the end of the transmission, the date and time of the terminal will be the current date and time you have in the PC.

This operation is also possible in a DOS environment using the DOSDL.EXE command (for more details see EasyGen™ User's Manual).

NOTE
Before sending a new application program to the terminal, it is necessary to delete the one currently in use. See par. 6.3 in EasyGen™ User's Manual.


Export

Choosing this command enables you to save your application specific files to be loaded by an operating system other than Windows 95/98/2000/ME/NT.

The program is saved on .EXP .CFG .INP .CMD files.

With these files you can use the program even in a computer without EasyGen™ or with an operating system different from Windows (see Appendix B in EasyGen™ User's Manual).

A text file .EXP contains the names of files necessary to send the EasyGen™ application to the terminal.

A .CFG file contains instructions to set the terminal's configuration.

One or more .INP files contain the table definition (one file per table). For each .INP file it is possible to use a corresponding .DAT file containing all the table data.

A .CMD file contains formatted instructions of the program developed by EasyGen™.

The application program and the tables assigned to it must be loaded onto the Formula terminal in compliance with the communication frame described in EasyGen™ User's Manual.


Exit

When this command is chosen, the following dialog box appears, which permits you to exit the EasyGen™ application package.


Edit Menu

The commands of this menu allow you to copy, insert, and delete program functions.

The command Paste inserts a previously copied function, below the current line.

If more than one program is opened, it is possible to copy or move a group of functions from one program to another.

Search

This command allows the user to search for a function inserted in the program. In this case the following window appears:

Once a function name has been chosen from the pull-down list, in the "Results" area you will be presented with a list of the occurrences of that function in the program you are working with.
By selecting a specific function and pressing the "Go" key, its position is immediately located and pointed to by the arrow in the program window. The "Function search" window will be closed. The same procedure can be obtained by double-clicking on the function name from the "Results" area.
The "Next" key allows scrolling the "Results" area list and therefore locating the occurences of program functions (scrolling). The "Function Search" window will not be closed.


Insert Menu

This menu presents the list of all the available functions for creating the program.

Each function can be inserted into the program by selecting the choice from the menu, or by selecting its corresponding icon.

Remark function

Beep Function

Clear Display Function

Input Barcode Function

Input Text Function

Input Number Function

Input Date Function

Input Time Function

Menu Function

Loop Function

Comparison Function

Go to Function

Mathematical Function

Find Function


Remark Function

Allows you to display on the Formula terminal up to four different comments anywhere in the display area:

The Remark window has four tabs, Remark1, Remark2…Remark4, for four comments.
The Terminal layout window shows the display status with the four comments.

The comment can be specified as a message from the programmer, a table field or the value of a variable.

Acting upon (X) and (Y) it is possible to position the initial coordinates of the comment.

The result of the comment function is visible in the window that simulates the display of the Formula terminal.


Beep Function

Allows the Formula terminal to emit a beep. Also it is possible to define its loudness, the pitch, and the duration.


Clear Display Function

Completely clears the display of the Formula terminal.


Input Barcode Function

Allows you to read a bar code and save the information in the field of a table or in a variable. It is possible to display a predefined comment in any position on the screen.

For the choice of bar code type to be read, it is necessary to choose the Limits option.

For each code type it is possible to define 3 acceptable lengths.

A value of 0 will accept any length. When there are one or two acceptable lengths, it is necessary to fill the remaining boxes with the same value. In addition, it is possible to handle the control digit or not, as desired.

The <Other> button permits access to other types of codes

With the Exception option, you can define an exit from the bar code acquisition mode by pressing a particular button, and continue with the program by jumping to a specified function.

The available keys for the Formula 734 are:

Other available Formula terminals may have more or less keys. See the relevant Formula terminal User Manual.

NOTE
It is only possible to jump to functions which are already defined in the application. The creation of a jump to a function that has not yet been defined must be done by successively returning to this function menu.

  • EAN128 & CODE 128

By enabling CODE 128 codes, it is possible to read, not only normal CODE 128 barcodes, but also single field EAN 128 codes.

By enabling EAN 128 codes, it is possible to read, not only single field EAN 128 barcodes, but also CODE 128 codes.

NOTE
To correctly read EAN 128 codes of more than one field, it is necessary to create the special EAN128tb table. (See Editor Tables). This table must have a number of fields greater than or equal to the maximum number of fields to be read. The EAN 128 code content will ALWAYS be assigned to the EAN128tb table. The code fields will automatically be separated and saved in their respective fields defined in the table, always starting from the first field. The EAN128tb table is made up of ONLY one record. Therefore it is necessary to save this data elsewhere before reading a new code (otherwise it will be overwritten).

Enabling multiple code types simultaneously

  • If data is to be saved in the EAN128tb table, all other code types read (different from EAN 128) will be saved in the specified field of the EAN128tb table.
  • If data is to be saved in a table other than EAN128tb (for example "table1"), all other code types read (different from EAN 128) will be saved in the specified table.

To test a program that allows reading EAN 128 codes using the simulator (see Run Menu):

  • use the "|" (Pipe) character as the first character of the code
  • use the "|" (Pipe) character as the field separator (instead of character 'GS')
  • For example: "|ONE|TWO|THREE"


Input Text Function

This function permits you to enter a sequence of characters from the Formula terminal keyboard and to save the information in a table field or in a variable. It is possible to display a fixed comment in a pre-defined position.

To set the maximum number of acceptable characters it is only necessary to click the Limits option.

With the Exception option, you can define an exit from the bar code acquisition mode by pressing a particular button, and continue with the program by jumping to a specified function.

The available keys for Formula 734 are:

Other available Formula terminals may have more or less keys (see the relevant Formula terminal User's Manual).

NOTE
It is only possible to jump to functions which are already defined in the application. The creation of a jump to a function that has not yet been defined must be done by successively returning to this function menu.


Input Number Function

This function allows the user to insert a number and to save the information in a table field or in a variable. It is possible to display a fixed comment in a predefined position.

To set the maximum number of acceptable characters it is only necessary to click the Limits option.

With the Exception option, you can define an exit from the bar code acquisition mode by pressing a particular button, and continue with the program by jumping to a specified function.

The available keys for Formula 734 are:

Other available Formula terminals may have more or less keys (see the relevant Formula terminal User Manual).

NOTE
It is only possible to jump to functions which are already defined in the application. The creation of a jump to a function that has not yet been defined must be done by successively returning to this function menu.


Input Date Function

This function permits the user to save the system date in a table field or in a variable.

To avoid possible errors, it is recommended that the field in which you wish to save the date be defined as a "date" field (See Editor Tables).


Input Time Function

This function permits the user to save the system time (handled by an internal clock in the terminal) in a table field or in a variable.

To avoid possible errors, it is recommended that the field in which you wish to save the date be defined as a "time" field (See Editor Tables).


Menu Function

Allows the creation of a menu with a maximum of 4 choices. For each choice it is possible to define the position, the key to press, the text, and the function to be executed.

The menu always uses a numerical key for the choice options.

NOTE
It is only possible to jump to functions which are already defined in the application. The creation of a jump to a function that has not yet been defined must be done by successively returning to this function menu.


Loop Function

This function allows the user to increment the index of three tables and define a function loop which repeats until a specified condition is met.

The loop begins with the function defined with the parameters in the window and ends with the function "Loop". This loop is repeated until a jump is made to a function which allows an exit.

The first time the program is used, or when a table is reloaded, the index is always pointing to the first record. The user can choose which index(es) to increment in the window of the Loop function.

If it is not incremented, the index always points to the same record, and therefore each successive code read will overwrite the previous one.


Comparision function

Comparison Function

The first element is compared with the second, and based on the result (true or false) a decision is made as to where the program continues.

The comparison can be made between numbers or character strings.

Both the first and the second element may be a constant or a table field.

In the case of numerical comparison, the constant must always be defined as the second element.

NOTE
It is only possible to jump to functions which are already defined in the application. The creation of a jump to a function that has not yet been defined must be done by successively returning to this function menu.


Go to Function

This function causes the program execution to jump to a pre-defined function. By using the down arrow, one obtains a list of all available functions.

NOTE
It is only possible to jump to functions which are already defined in the application. The creation of a jump to a function that has not yet been defined must be done by successively returning to this function menu.


Mathematical function

Mathematical Operation Function

This function permits the execution of arithmetic operations or string operations. The result can be saved in a table field, in a variable, or in the index of a table.

The first element of the operation may be a constant, a table field, the value of a variable or the index of a table.

The available arithmetic operations are the four base operations, addition, subtraction, multiplication, and division, and also percentage. A null operation may also be assigned by selection the option "none".

Two string operations are available: substring, or concatenation of the string containing the first element with the string containing the second element.

The second element of an operation between numbers or strings may be a constant, a table field, the value of a variable, or the index of a table. In the case where the arithmetic operation is an assignment, the second element must not be defined.


Find Function

This function allows the user to search for a constant, the value of a table field or the value of a variable within a table.

The Information option allows the user to define the type of search which can be sequential, or in the case of an ordered table, according to the field to be searched, with binary method (also called "dichotomous") and may begin with the first record with the current record (index value).

To obtain the best results using the binary method, it is advised to use tables (relative to the search field) that are:
- completely full
- already ordered
- without duplicate elements

The Go to option defines the function to execute after the search.

Based on the results of the search, the program will jump to one of two functions specified.
The result of the search positions the table index at the record containing the field searched for if the search is of the equivalence type, or at the first record which satisfies the requested comparison.

If no record is found, the index variable maintains its current position.

NOTE
It is only possible to jump to functions which are already defined in the application. The creation of a jump to a function that has not yet been defined must be done by successively returning to this function menu.


Run Menu

This function allows to simulate the execution of the application program.

Compile

This command allows checking the correct syntax of each function. The compilation is followed by a message. If an error has occured, the message reports its type, while the arrow in the program ApWin will signal the cell containing the wrong function.

Start

This function allows to start the simulation of the application program until there is an acquisition function. In this case a window appears where you can insert the requested information.

In this operation , if you press the <Watch> button, you can see the variables and tables contents.

Stop

This function stops the simulation of the application program.

Step

This function runs the step-by-step simulation of the application program.


Tools Menu

When a EasyGen™ program is opened, the Tools menu is activated in order to configure tables, variables, and the terminal.

  • Editor Tables
  • Editor Variables
  • Options


Editor Tables

Choosing this command causes a window of the following type to be displayed:

The programmer may define up to 15 General type tables which may be used for reading or writing.

Each table may be associated with .DAT file which has the same name as the table and which contains its data.

The format of the .DAT file must be compliant with that of the table defined with EasyGen™.

Each field must be divided by the character "|" (pipe) and each record must be positioned on a single line.

EXAMPLE 1

Suppose that we have defined with EasyGen™ a table "Fruits" consisting of two fields:

Fruit : 10 characters

Code : 5 characters.

The file with extension .DAT is called "FRUITS.DAT" and contains the data:

Pearxxxxxx |00123 |

Orangexxxx |00257 |

Melonxxxxx |00378 |

When the program created with EasyGen™ is sent to a Formula terminal, if files with the extension .DAT (having the same names as tables used within the program itself) are found within the same directory where the program is stored, EasyGen™ loads these data files onto the terminal as well.

CAUTION
Take note of tables which are initially empty and which will be written to.
Tables are loaded from the first record, up to the first empty record. If a table is written in a random order, it is possible that empty records will exist between the first and last records. In this case there will certainly be a loss of data.

Each table is distinguished by:

Number

The number is a progressive number which uniquely identifies the table and corresponds to the order in which it was sent to the Formula terminal.

Name

The name of the table is an alphanumeric field of maximum 8 characters.

N.max

Maximum number of records which can be read into this table.

Before inserting the number of records which comprise the table, it is necessary to verify the quantity of memory available on the Formula terminal. The maximum number of records allowed depends on the available memory on the Formula Terminal.

EAN128

By checking the EAN128 box, a special table is defined for EAN 128 barcode reading. The table is automatically assigned the name EAN128tb. This table must have a number of fields greater or equal to the maximum number of fields to be read. For more details see Input Barcode Function.

Add a table

Delete a table

ATTENTION

It is not possible to remove tables which have already been called by one or more program functions.

There is an index for each table which identifies the record into which the variable or the result of an acquisition will be stored. The index may be repositioned by the programmer to point to any record in the table.

When the tables are loaded into the Formula terminal, the indexes are always positioned at the first record.

The Fields option permits the definition of the fields of which each record is composed.

A record may be a maximum of 256 characters and may contain up to 30 fields. Variable-length records may not be defined.

Each field is distinguished by:

Number

The number is a progressive number which uniquely identifies a field and corresponds to the order in which it was sent to the Formula terminal.

Name

The name of the field is an alphanumeric field with a maximum length of 10 characters.

Type

The field type may be selected from:

  • Normal (for example code, price, location, ...)
  • Time (internal to the terminal) contains the time in the format hh:mm. Every time a record is updated, the time will be automatically updated as well.
  • Date (internal to the terminal) contains the date in the format dd/mm/yy. Every time a record is updated, the date will be automatically updated as well.

For each field of type Normal it is possible to define:

  • Alignment

It is also possible to define the alignment of data within the field, whenever the fill character is not defined as being equal to zero.

  • Fill

The character to be used to complete acquired data if the data has a length less than that of the field length.

Space: data is considered to be alphanumeric.

Zero: data is considered to be numeric and the alignment is set flush right. This selection assumes relative importance when the data is used (for example, equivalence tests and arithmetic operations).
  • Size

It is possible to enable control of the length of data to be inserted into the field.

Control is done by verifying that the length is within a minimum and a maximum, or is equal to the maximum defined value.

The maximum length allowed is 32 characters.

Length control is disabled as the default.

  • Check character from…to

By defining a range of characters, it is possible to enable control over the type of characters which will be inserted into the field, defining a range of possible characters.

By default, character control is between the character space and the character z. For whole numbers insert the control from "0" to "9". For real numbers insert the control from "." to "9".

Add field

Delete field

ATTENTION

It is not possible to remove fields contained in the tables which have already been called by one or more program functions.


Editor Variables

Choosing this command causes a window of the following type to be displayed:

The variables are used by the application to store temporary data.

There are 7 temporary variables of 32 characters available.

Each variable is distinguished by a name which enables recognition.

To change the name of a variable it is only necessary to select it, modify the name, and press the <Tab> key to skip to the next variable, or <OK> to exit this window.


Options

Choosing this command causes a window of the following type to be displayed:

In this window it is possible to define the communications parameters between the Formula terminal and the host computers.

In the General option the user must enter the speed with which the Formula terminal will communicate with the host computer, the number of data bits, the parity, mode, and type of communication (RS-232, RS-485, Eavesdrop).

The Protocol option defines how the records will arrive at the host computer when they are requested to be unloaded (the communication frame is declared in this window).

The identifier of the Formula terminal can be defined, the transmission delay expressed in milliseconds, the type of message integrity control, and the characters indicating begin block, end block, and end read.

The suggested values are those required to communicate with the Formula terminal using Datalogic S.p.A. programs such as SysTools™2001.

The Message option allows the user to define the courtesy message which the Formula terminal displays when it is placed in the loading unit and connected to the host computer.

When Eavesdrop communication is selected, checksum should be set to none and Start of Block/End of Block to none.


Utility Menu

The Utility menu can contain two options, "Initiate…" and "Communication…".

Initiate can be used for updating the interpreter program on the Formula terminal. It allows the user to find the file with a .HEX or a .H00extension in the current directory or in the entire disk.

This operation is also possible using the DOSDL.EXE command in a DOS environment.

Communication allows selecting the type of data transfer to use towards the terminal.


Window Menu

The menu option is absolutely Windows standard and permits the user to choose the most convenient display mode when more than one window is open at the same time:

  • Cascading, the windows are displayed with standard dimensions, one on top of the other, but slightly displaced so that each one can be seen.
  • Tiled, the windows opened at the moment are automatically scaled and occupy all available space without overlapping.

The windows can be minimized and represented by an icon on the screen.

  • Arrange icons, the windows present on the screen will be aligned


Transmission

Transmission of the Application Program Outside of the Windows Environment

The application program developed with EasyGen™ may be loaded directly by DOS, without needing to pass through Windows 95/98/2000/ME/NT, by using the program DOSDL.EXE. For more details refer to EasyGen™ User's Manual.


Data to the host

Transmission of Data to the Host Computer

Any time the user desires to place the Formula terminal in communication with the host computer, it is only necessary to insert the terminal into the cradle. As soon as it has been inserted, if the cradle is correctly connected, the Formula terminal beeps twice.

The transmission mode varies according to the protocol used.

For additional information on transmission modes, refer to the interpreter program EIXXX_YYY.HEX in the EasyGen™ User's Manual.


Index

EasyGen™

  • Description of the Applications Package
  • Minimum Configuration Required
  • Installation
  • Use and Functioning